;lisp routines for borders
;including
;REV      for defining the rev letter within border
;DWGNO    for defining the drawing number within border
;OF       for defining the number of sheets on the drawing
;FILENAME for defining the file name within border.
;these are usefull for all borders in the same file.
; ---- System variable save --------------------------------------------
(defun MODES (a)
   (setq MLST '())
   (repeat (length a)
      (setq MLST (append MLST (list (list (car a) (getvar (car a))))))
      (setq a (cdr a)))
);END DEFUN MODES

; ---- System variable restore -----------------------------------------
(defun MODER ()
   (repeat (length MLST)
      (setvar (caar MLST) (cadar MLST))
      (setq MLST (cdr MLST)))
(setvar "highlight" 1)
);END DEFUN MODER
;******************************************** redefines special blocks
(DEFUN C:REV ( / T)
  (SETQ T (getstring 1 "\nWhat is the REV letter: "))
  (MAKETEXT T 0.15 "REVLTR" 1 "BORDER")
(PRINC)
);END DEFUN REV
(DEFUN C:DWGNO ( / DWGNUM)
  (SETQ DWGNUM (getstring 1 "\nWhat is the DRAWING NUMBER: "))
  (MAKETEXT DWGNUM 0.15 "DWGNO" 0 "BORDER")
(PRINC)
);END DEFUN
(DEFUN C:FILENAME ( / T)
;**********************************************************
;EXTRACTS JUST THE FILE NAME
;( / FULL LEN CNT FLAG )
(SETQ FULL (getvar "dwgname")
      LEN (strlen full)
      CNT 0
      FLAG NIL)
(WHILE (AND (<= CNT 8)
            (NULL FLAG))
       (IF (OR (>= (SETQ CNT (1+ CNT)) LEN)
               (= "\\" (SETQ A (SUBSTR FULL (- LEN CNT) 1)))
               (= "/" A)
               (= ":" A))
           (SETQ FLAG 1)))
(SETQ FILENAME (SUBSTR FULL (- LEN CNT -1) (1+ CNT)))
;**********************************************************
(SETQ TEMP (GETSTRING (STRCAT "\nWhat is the FILE NAME <"
                              FILENAME
                              ">:")))
(IF (/= TEMP "")              ;SETS DEFAULT IF CARAGE RETUREN IS USED
    (SETQ T TEMP)
    (SETQ T FILENAME))
(MAKETEXT T 0.1 "FILENAME" 1 "BORDER")
(PRINC)
);END DEFUN
(DEFUN C:OF ( / T)
  (SETQ T (getstring "\nHow many sheets are in this drawing: "))
  (MAKETEXT T 0.1 "OF" 1 "BORDER")
(PRINC)
);END DEFUN
;*****************************************************************************
(DEFUN MAKETEXT (TXT TH BN JUST STY / MLST UCSFLAG T) ;PASSED TEXT, HIGHT, BLOCK NAME, JUSTIFICATION, STYLE
(MODES '("CMDECHO" "REGENMODE" "TEXTSTYLE")) ;MLST VAR
;(SETVAR "CMDECHO" 0 )
(SETVAR "REGENMODE" 0)
(IF (/= (TRANS (LIST 0.0 0.0 0.0) 0 1) (LIST 0.0 0.0 0.0))
    (PROGN
        (SETQ UCSFLAG 1)
        (COMMAND "UCS" "W")))
;(SETQ INP (LIST 0.0 0.0 0.0)
(SETQ INP (GETVAR "VIEWCTR")
      T (LIST (CONS 0 "TEXT")         ;ENT TYPE
              (CONS 8 "0")            ;LAYER
              (CONS 5 "3")            ;
              (LIST 10 (CAR INP)(CADR INP)(CADDR INP));INSERT POINT
              (CONS 40 TH)            ;HIGHT
              (CONS 1 TXT)            ;TEXT
              (CONS 50 0.0)           ;ROTATION
              (CONS 41 0.85)          ;WIDTH
              (CONS 51 0.0)           ;OBLIQUING ANGLE
              (CONS 7 STY)            ;STYLE
              (CONS 71 0)             ;GENERATION FLAG
              (CONS 72 JUST)          ;HORZ JUST
              (CONS 73 0)             ;VERT JUST
              (LIST 11 (CAR INP)(CADR INP)(CADDR INP));ALIGNMENT PT
              (LIST 210 0.0 0.0 1.0)));EXTRUSION DIRECTION VECTOR
(ENTMAKE T)
(IF (TBLSEARCH "BLOCK" BN)        ;TEST FOR BLOCK EXISTANCE
    (COMMAND ".BLOCK" BN "Y" "NONE" (GETVAR "VIEWCTR") (ENTLAST) "")
    (COMMAND ".BLOCK" BN     "NONE" (GETVAR "VIEWCTR") (ENTLAST) ""))
;    (COMMAND ".BLOCK" BN "Y" "NONE" "0.0,0.0,0.0" (ENTLAST) "")
;    (COMMAND ".BLOCK" BN "NONE" "0.0,0.0,0.0" (ENTLAST) ""))
(IF (NOT (NULL UCSFLAG))
        (COMMAND "UCS" "P"))
(MODER));END DEFUN MAKETEXT
